diff --git a/client/suse/compat-suse.c b/client/suse/compat-suse.c
index 85b01df12..d2fdd9a49 100644
--- a/client/suse/compat-suse.c
+++ b/client/suse/compat-suse.c
@@ -6316,457 +6463,480 @@ __ifsysctl_get_tristate(ni_var_array_t *vars, const char *path, const char *ifna
 }
 
 static ni_bool_t
-__ni_suse_read_ifsysctl(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+ni_suse_ifcfg_parse_ifsysctl_ipv4(ni_suse_ifcfg_t *ifcfg, ni_var_array_t *ifsysctl)
 {
-	ni_var_array_t ifsysctl = NI_VAR_ARRAY_INIT;
-	ni_netdev_t *dev = compat->dev;
-	char pathbuf[PATH_MAX];
-	const char *dirname;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_ipv4_devinfo_t *ipv4;
-	ni_ipv6_devinfo_t *ipv6;
+
+	/*
+	 * On L2 ports, we've disabled L3 / IPv4 already.
+	 */
+	if (ifcfg->l2only)
+		return TRUE;
+
+	if (!(ipv4 = ni_netdev_get_ipv4(dev)))
+		return FALSE;
+
+	/* Note: no conf.enable and conf.arp-verify in sysctl */
+
+	__ifsysctl_get_tristate(ifsysctl, "net/ipv4/conf", dev->name,
+			"forwarding", &ipv4->conf.forwarding);
+	__ifsysctl_get_tristate(ifsysctl, "net/ipv4/conf", dev->name,
+			"arp_notify", &ipv4->conf.arp_notify);
+	__ifsysctl_get_tristate(ifsysctl, "net/ipv4/conf", dev->name,
+			"accept_redirects", &ipv4->conf.accept_redirects);
+
+	return TRUE;
+}
+
+static ni_bool_t
+ni_suse_ifcfg_parse_ifsysctl_ipv6(ni_suse_ifcfg_t *ifcfg, ni_var_array_t *ifsysctl)
+{
 	ni_tristate_t disable_ipv6 = NI_TRISTATE_DEFAULT;
+	ni_netdev_t *dev = ifcfg->compat->dev;
+	ni_ipv6_devinfo_t *ipv6;
 
-	dirname = ni_dirname(sc->pathname);
-	if (ni_string_empty(dirname))
+	if (!(ipv6 = ni_netdev_get_ipv6(dev)))
 		return FALSE;
 
-	ni_var_array_copy(&ifsysctl, &__ni_suse_global_ifsysctl);
-	snprintf(pathbuf, sizeof(pathbuf), "%s/%s-%s", dirname,
-			__NI_SUSE_IFSYSCTL_FILE, dev->name);
-	if (ni_isreg(pathbuf)) {
-		ni_ifsysctl_file_load(&ifsysctl, pathbuf);
-	}
+	/*
+	 * First, get sysctl's affecting also "IPv6 L2" aka
+	 * stable secret for the fe80 link-address assignment.
+	 */
+	__ifsysctl_get_int(ifsysctl, "net/ipv6/conf", dev->name,
+			"addr_gen_mode", &ipv6->conf.addr_gen_mode, 10);
 
-	ipv4 = ni_netdev_get_ipv4(dev);
-	ni_tristate_set(&ipv4->conf.enabled, TRUE);
-	/* no conf.enable and conf.arp-verify in sysctl */
-	__ifsysctl_get_tristate(&ifsysctl, "net/ipv4/conf", dev->name,
-				"forwarding", &ipv4->conf.forwarding);
-	__ifsysctl_get_tristate(&ifsysctl, "net/ipv4/conf", dev->name,
-				"arp_notify", &ipv4->conf.arp_notify);
-	__ifsysctl_get_tristate(&ifsysctl, "net/ipv4/conf", dev->name,
-				"accept_redirects", &ipv4->conf.accept_redirects);
+	__ifsysctl_get_ipv6(ifsysctl, "net/ipv6/conf", dev->name,
+			"stable_secret", &ipv6->conf.stable_secret);
 
-	ipv6 = ni_netdev_get_ipv6(dev);
-	ni_tristate_set(&ipv6->conf.enabled, !__ni_ipv6_disbled);
-	if (__ni_ipv6_disbled) {
-		ni_var_array_destroy(&ifsysctl);
+	/*
+	 * On L2 ports, we may need the ipv6 link e.g. for nsna
+	 * ping monitoring, but already disabled e.g accept_ra
+	 * to avoid RA processing affecting the IPv6 L3 autoconf
+	 * aka auto6 (SLAAC) & dhcp6 and don't parse static IPs.
+	 */
+	if (ifcfg->l2only)
 		return TRUE;
-	}
-	__ifsysctl_get_tristate(&ifsysctl, "net/ipv6/conf", dev->name,
-				"disable_ipv6", &disable_ipv6);
+
+	/*
+	 * When IPv6 is disabled via sysctl, we're done
+	 */
+	if (__ni_ipv6_disbled)
+		ni_tristate_set(&ipv6->conf.enabled, FALSE);
+	__ifsysctl_get_tristate(ifsysctl, "net/ipv6/conf", dev->name,
+			"disable_ipv6", &disable_ipv6);
 	if (ni_tristate_is_set(disable_ipv6))
 		ni_tristate_set(&ipv6->conf.enabled, !disable_ipv6);
+	if (ni_tristate_is_disabled(ipv6->conf.enabled))
+		return TRUE;
 
-	__ifsysctl_get_tristate(&ifsysctl, "net/ipv6/conf", dev->name,
-				"forwarding", &ipv6->conf.forwarding);
+	__ifsysctl_get_tristate(ifsysctl, "net/ipv6/conf", dev->name,
+			"forwarding", &ipv6->conf.forwarding);
 
-	__ifsysctl_get_int(&ifsysctl, "net/ipv6/conf", dev->name,
-				"accept_ra", &ipv6->conf.accept_ra, 10);
+	__ifsysctl_get_int(ifsysctl, "net/ipv6/conf", dev->name,
+			"accept_ra", &ipv6->conf.accept_ra, 10);
 	if (ipv6->conf.accept_ra > NI_IPV6_ACCEPT_RA_ROUTER)
 		ipv6->conf.accept_ra = NI_IPV6_ACCEPT_RA_ROUTER;
 	else
 	if (ipv6->conf.accept_ra < NI_IPV6_ACCEPT_RA_DEFAULT)
 		ipv6->conf.accept_ra = NI_IPV6_ACCEPT_RA_DEFAULT;
 
-	__ifsysctl_get_int(&ifsysctl, "net/ipv6/conf", dev->name,
-				"accept_dad", &ipv6->conf.accept_dad, 10);
+	__ifsysctl_get_int(ifsysctl, "net/ipv6/conf", dev->name,
+			"accept_dad", &ipv6->conf.accept_dad, 10);
 	if (ipv6->conf.accept_dad > NI_IPV6_ACCEPT_DAD_FAIL_PROTOCOL)
 		ipv6->conf.accept_dad = NI_IPV6_ACCEPT_DAD_FAIL_PROTOCOL;
 	else
 	if (ipv6->conf.accept_dad < NI_IPV6_ACCEPT_DAD_DEFAULT)
 		ipv6->conf.accept_dad = NI_IPV6_ACCEPT_DAD_DEFAULT;
 
-	__ifsysctl_get_tristate(&ifsysctl, "net/ipv6/conf", dev->name,
+	__ifsysctl_get_tristate(ifsysctl, "net/ipv6/conf", dev->name,
 				"autoconf", &ipv6->conf.autoconf);
 
-	__ifsysctl_get_int(&ifsysctl, "net/ipv6/conf", dev->name,
+	__ifsysctl_get_int(ifsysctl, "net/ipv6/conf", dev->name,
 				"use_tempaddr", &ipv6->conf.privacy, 10);
 	if (ipv6->conf.privacy > NI_IPV6_PRIVACY_PREFER_TEMPORARY)
 		ipv6->conf.privacy = NI_IPV6_PRIVACY_PREFER_TEMPORARY;
 	else if (ipv6->conf.privacy < NI_IPV6_PRIVACY_DEFAULT)
 		ipv6->conf.privacy = NI_IPV6_PRIVACY_DISABLED;
 
-	__ifsysctl_get_tristate(&ifsysctl, "net/ipv6/conf", dev->name,
-				"accept_redirects", &ipv6->conf.accept_redirects);
+	__ifsysctl_get_tristate(ifsysctl, "net/ipv6/conf", dev->name,
+			"accept_redirects", &ipv6->conf.accept_redirects);
 
-	__ifsysctl_get_int(&ifsysctl, "net/ipv6/conf", dev->name,
-				"addr_gen_mode", &ipv6->conf.addr_gen_mode, 10);
+	return TRUE;
+}
+
+static ni_bool_t
+ni_suse_ifcfg_parse_ifsysctl(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
+{
+	ni_var_array_t ifsysctl = NI_VAR_ARRAY_INIT;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
+	char pathbuf[PATH_MAX];
+	const char *dirname;
 
-	__ifsysctl_get_ipv6(&ifsysctl, "net/ipv6/conf", dev->name,
-				"stable_secret", &ipv6->conf.stable_secret);
+	dirname = ni_dirname(sc->pathname);
+	if (ni_string_empty(dirname))
+		return FALSE;
 
+	ni_var_array_copy(&ifsysctl, &__ni_suse_global_ifsysctl);
+	snprintf(pathbuf, sizeof(pathbuf), "%s/%s-%s", dirname,
+			__NI_SUSE_IFSYSCTL_FILE, dev->name);
+	if (ni_isreg(pathbuf)) {
+		ni_ifsysctl_file_load(&ifsysctl, pathbuf);
+	}
+
+	ni_suse_ifcfg_parse_ifsysctl_ipv4(ifcfg, &ifsysctl);
+	ni_suse_ifcfg_parse_ifsysctl_ipv6(ifcfg, &ifsysctl);
 	ni_var_array_destroy(&ifsysctl);
 	return TRUE;
 }
 
-static ni_compat_netdev_t *
-__ni_suse_find_compat(ni_compat_netdev_array_t *netdevs, const char *name)
+static ni_bool_t
+ni_suse_ifcfg_parse_linkinfo(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_compat_netdev_t *compat;
-	unsigned int i;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 
-	for (i = 0; i < netdevs->count; ++i) {
-		compat = netdevs->data[i];
-		if (ni_string_eq(compat->dev->name, name))
-			return compat;
-	}
-	return NULL;
+	ni_sysconfig_get_integer(sc, "MTU", &dev->link.mtu);
+
+	return TRUE;
 }
 
-static ni_netdev_t *
-__ni_suse_find_compat_device(ni_compat_netdev_array_t *netdevs, const char *name)
+static inline ni_bool_t
+ni_suse_ifcfg_parse_control(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_compat_netdev_t *compat = __ni_suse_find_compat(netdevs, name);
-	return compat ? compat->dev : NULL;
+	if (!(ifcfg->compat->control = ni_suse_ifcfg_parse_startmode(ifcfg->config)))
+		return FALSE;
+
+	return TRUE;
 }
 
-static ni_bool_t
-__ni_suse_set_link_master(ni_netdev_t *dev, const char *master, const char *ifcfg)
+static inline ni_bool_t
+ni_suse_ifcfg_parse_iftypes(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_ipv4_devinfo_t *ipv4;
-	ni_ipv6_devinfo_t *ipv6;
-
-	if (ni_string_empty(dev->link.masterdev.name))
-		ni_netdev_ref_set_ifname(&dev->link.masterdev, master);
-	else
-	if (!ni_string_eq(master, dev->link.masterdev.name)) {
-		/*
-		 * The ifcfg device hierarchy _is_ broken. But it is quite hard
-		 * to fix it: the only possibilities are to remove the port/slave
-		 * from the 2nd master to keep the already assigned master intact
-		 * or to override the master.
-		 * But as we cannot judge which master config is correct and which
-		 * not, we let the upper layers decide how to handle this.
-		 */
-		ni_warn("ifcfg-%s: cannot enslave %s to %s, already enslaved by %s",
-				ifcfg, dev->name, master, dev->link.masterdev.name);
+	if (try_loopback(ifcfgs, ifcfg)   < 0 ||
+	    try_ovs_system(ifcfgs, ifcfg) < 0 ||
+	    try_ovs_bridge(ifcfgs, ifcfg) < 0 ||
+	    try_bonding(ifcfgs, ifcfg)    < 0 ||
+	    try_team(ifcfgs, ifcfg)       < 0 ||
+	    try_bridge(ifcfgs, ifcfg)     < 0 ||
+	    try_vlan(ifcfgs, ifcfg)       < 0 ||
+	    try_vxlan(ifcfgs, ifcfg)      < 0 ||
+	    try_macvlan(ifcfgs, ifcfg)    < 0 ||
+	    try_dummy(ifcfgs, ifcfg)      < 0 ||
+	    try_tunnel(ifcfgs, ifcfg)     < 0 ||
+	    try_ppp(ifcfgs, ifcfg)        < 0 ||
+	    try_wireless(ifcfgs, ifcfg)   < 0 ||
+	    try_infiniband(ifcfgs, ifcfg) < 0 ||
+	    /* keep ethernet the last one */
+	    try_ethernet(ifcfgs, ifcfg)   < 0)
 		return FALSE;
-	}
-
-	if ((ipv4 = ni_netdev_get_ipv4(dev)))
-		ni_tristate_set(&ipv4->conf.enabled, FALSE);
-	if ((ipv6 = ni_netdev_get_ipv6(dev)))
-		ni_tristate_set(&ipv6->conf.enabled, FALSE);
 
 	return TRUE;
 }
 
-static ni_compat_netdev_t *
-__ni_suse_create_compat_slave(ni_compat_netdev_array_t *netdevs, ni_compat_netdev_t *master, const char *master_name, const char *slave)
+static ni_bool_t
+ni_suse_ifcfg_parse_foreach(ni_suse_ifcfg_array_t *ifcfgs,
+		ni_bool_t (*parse)(ni_suse_ifcfg_array_t *, ni_suse_ifcfg_t *))
 {
-	ni_ifworker_control_t control = { "hotplug", NULL, FALSE, FALSE, NI_TRISTATE_DEFAULT, 0, 0 };
-	ni_compat_netdev_t *compat;
-	ni_client_state_t *m_cs;
-	ni_client_state_t *s_cs;
-
-	compat = ni_compat_netdev_new(slave);
-	if (!compat)
-		return NULL;
+	ni_suse_ifcfg_t *ifcfg;
+	unsigned int i;
 
-	if (master_name)
-		__ni_suse_set_link_master(compat->dev, master_name, master->dev->name);
-	else
-		__ni_suse_set_link_master(compat->dev, master->dev->name, master->dev->name);
+	if (!ifcfgs || !parse)
+		return FALSE;
 
-	/* apply control defaults  */
-	compat->control = ni_ifworker_control_clone(&control);
+	for (i = 0; i < ifcfgs->count; ++i) {
+		ifcfg = ifcfgs->data[i];
+		if (ifcfg->broken)
+			continue;
 
-	/* copy origin from master */
-	m_cs = ni_netdev_get_client_state(master->dev);
-	s_cs = ni_netdev_get_client_state(compat->dev);
-	ni_string_dup(&s_cs->config.origin, m_cs->config.origin);
+		if (!parse(ifcfgs, ifcfg))
+			ifcfg->broken = TRUE;
+	}
+	return TRUE;
+}
 
-	ni_compat_netdev_array_append(netdevs, compat);
+static ni_bool_t
+ni_suse_ifcfg_parse(ni_suse_ifcfg_array_t *ifcfgs)
+{
+	if (!ni_suse_ifcfg_parse_foreach(ifcfgs, ni_suse_ifcfg_parse_control)   ||
+	    !ni_suse_ifcfg_parse_foreach(ifcfgs, ni_suse_ifcfg_parse_iftypes)   ||
+	    !ni_suse_ifcfg_parse_foreach(ifcfgs, ni_suse_ifcfg_parse_linkinfo)  ||
+	    !ni_suse_ifcfg_parse_foreach(ifcfgs, ni_suse_ifcfg_parse_ifsysctl)  ||
+	    !ni_suse_ifcfg_parse_foreach(ifcfgs, ni_suse_ifcfg_parse_ethtool)	||
+	    !ni_suse_ifcfg_parse_foreach(ifcfgs, ni_suse_ifcfg_parse_firewall)  ||
+	    !ni_suse_ifcfg_parse_foreach(ifcfgs, ni_suse_ifcfg_parse_scripts)   ||
+	    !ni_suse_ifcfg_parse_foreach(ifcfgs, ni_suse_ifcfg_parse_bootproto))
+		return FALSE;
 
-	return compat;
+	return TRUE;
 }
 
-static void
-__ni_suse_adjust_bond_slaves(ni_compat_netdev_array_t *netdevs, ni_compat_netdev_t *master)
+/*
+ * Given a basename like "IPADDR", try to find all variables with this
+ * prefix (eg "IPADDR", "IPADDR_0", "IPADDR_1", ...) and invoke the provided function
+ * for each. Note, this passes the variable suffix ("", "_0", "_1") rather than
+ * the full variable name into the called function.
+ */
+static int
+__process_indexed_variables(const ni_sysconfig_t *sc, ni_netdev_t *dev,
+				const char *basename,
+				ni_bool_t (*func)(const ni_sysconfig_t *, ni_netdev_t *, const char *))
 {
-	ni_bonding_t *bond = ni_netdev_get_bonding(master->dev);
-	ni_bonding_slave_t *slave;
-	const char *slave_name;
-	ni_netdev_t *dev;
-	unsigned int i;
+	ni_string_array_t names = NI_STRING_ARRAY_INIT;
+	unsigned int i, pfxlen;
 
-	for (i = 0; i < bond->slaves.count; ++i) {
-		slave = bond->slaves.data[i];
-		if (!slave || ni_string_empty(slave->device.name))
-			continue;
-		slave_name = slave->device.name;
-		dev = __ni_suse_find_compat_device(netdevs, slave_name);
-		if (dev) {
-			__ni_suse_set_link_master(dev, master->dev->name, master->dev->name);
-		} else {
-			__ni_suse_create_compat_slave(netdevs, master, master->dev->name, slave_name);
+	if (!ni_sysconfig_find_matching(sc, basename, &names))
+		return 1;
+
+	pfxlen = strlen(basename);
+	for (i = 0; i < names.count; ++i) {
+		if (!func(sc, dev, names.data[i] + pfxlen)) {
+			ni_string_array_destroy(&names);
+			return -1;
 		}
 	}
+	ni_string_array_destroy(&names);
+	return 0;
 }
 
-static void
-__ni_suse_adjust_team_ports(ni_compat_netdev_array_t *netdevs, ni_compat_netdev_t *master)
+/*
+ * Given a base name and a suffix (eg "IPADDR" and "_1"), build a variable name
+ * and look it up.
+ */
+static ni_var_t *
+__find_indexed_variable(const ni_sysconfig_t *sc, const char *basename, const char *suffix)
 {
-	ni_team_t *team = ni_netdev_get_team(master->dev);
-	const char *port;
-	ni_netdev_t *dev;
-	ni_compat_netdev_t *compat;
-	unsigned int i;
-	ni_bool_t nsna_enabled = FALSE;
-	ni_team_link_watch_t *lw;
-	ni_ipv6_devinfo_t *ipv6;
+	ni_var_t *res;
+	char namebuf[64];
 
-	for (i = 0; i < team->link_watch.count; i++) {
-		lw = team->link_watch.data[i];
-		if (lw && lw->type == NI_TEAM_LINK_WATCH_NSNA_PING)
-			nsna_enabled = TRUE;
-	}
+	snprintf(namebuf, sizeof(namebuf), "%s%s", basename, suffix);
+	res = ni_sysconfig_get(sc, namebuf);
+	if (res && (res->value == NULL || res->value[0] == '\0'))
+		res = NULL;
+	return res;
+}
 
-	for (i = 0; i < team->ports.count; i++) {
-		if (!team->ports.data[i])
-			continue;
-		port = team->ports.data[i]->device.name;
-		compat = __ni_suse_find_compat(netdevs, port);
-		if (!compat)
-			compat = __ni_suse_create_compat_slave(netdevs, master, master->dev->name, port);
 
-		if (compat && (dev = compat->dev)) {
-			if (!__ni_suse_set_link_master(dev, master->dev->name, master->dev->name))
-				continue;
-			if (nsna_enabled && (ipv6 = ni_netdev_get_ipv6(dev)))
-				ni_tristate_set(&ipv6->conf.enabled, TRUE);
+static ni_suse_ifcfg_t *
+ni_suse_ifcfg_new(void)
+{
+	ni_suse_ifcfg_t *ifcfg;
 
-			compat->port.type = NI_IFTYPE_TEAM;
-			compat->port.conf.team = team->ports.data[i]->config;
-		}
-	}
+	ifcfg = calloc(1, sizeof(*ifcfg));
+	return ifcfg;
 }
 
 static void
-__ni_suse_adjust_bridge_ports(ni_compat_netdev_array_t *netdevs, ni_compat_netdev_t *master)
+ni_suse_ifcfg_free(ni_suse_ifcfg_t *ifcfg)
 {
-	ni_bridge_t *bridge = ni_netdev_get_bridge(master->dev);
-	const char *port;
-	ni_netdev_t *dev;
-	unsigned int i;
-
-	for (i = 0; i < bridge->ports.count; ++i) {
-		port = bridge->ports.data[i]->ifname;
-		dev = __ni_suse_find_compat_device(netdevs, port);
-		if (dev) {
-			__ni_suse_set_link_master(dev, master->dev->name, master->dev->name);
-		} else {
-			__ni_suse_create_compat_slave(netdevs, master, master->dev->name, port);
+	if (ifcfg) {
+		if (ifcfg->config) {
+			ni_sysconfig_free(ifcfg->config);
+			ifcfg->config = NULL;
+		}
+		if (ifcfg->compat) {
+			ni_compat_netdev_free(ifcfg->compat);
+			ifcfg->compat = NULL;
 		}
+		free(ifcfg);
 	}
 }
 
-static void
-__ni_suse_adjust_ovs_system(ni_compat_netdev_t *compat)
+static ni_suse_ifcfg_t *
+ni_suse_ifcfg_new_missing(ni_suse_ifcfg_t *from, const char *ifname)
 {
-	static const ni_ifworker_control_t control = {
-		"hotplug", NULL, FALSE, FALSE, NI_TRISTATE_DISABLE, 0, 0
-	};
-	ni_ipv4_devinfo_t *ipv4;
-	ni_ipv6_devinfo_t *ipv6;
+	ni_suse_ifcfg_t *ifcfg;
 
-	/*
-	 * This datapath device does not need any setup (not even link up),
-	 * but as it is actively used as master device for all bridge ports
-	 * so we have to consider it... adjust it as good as we can.
-	 * We don't have any "do not set UP the link up" flag until now...
-	 */
-	compat->control = ni_ifworker_control_clone(&control);
-	if ((ipv4 = ni_netdev_get_ipv4(compat->dev)))
-		ni_tristate_set(&ipv4->conf.enabled, FALSE);
-	if ((ipv6 = ni_netdev_get_ipv6(compat->dev)))
-		ni_tristate_set(&ipv6->conf.enabled, FALSE);
-}
+	if (!from || !from->config || !ifname)
+		return NULL;
 
-static void
-__ni_suse_create_ovs_system(ni_compat_netdev_array_t *netdevs, const char *ovs_system, const char *origin)
-{
-	ni_compat_netdev_t *compat;
-	ni_client_state_t *cs;
-	const char *sibling;
+	if (!(ifcfg = ni_suse_ifcfg_new()))
+		goto error;
 
-	if ((compat = __ni_suse_find_compat(netdevs, ovs_system)))
-		return;
+	if (!(ifcfg->config = ni_sysconfig_new(from->config->pathname)))
+		goto error;
 
-	compat = ni_compat_netdev_new(ovs_system);
+	if (!(ifcfg->compat = ni_compat_netdev_new(ifname)))
+		goto error;
 
-	__ni_suse_adjust_ovs_system(compat);
-	cs = ni_netdev_get_client_state(compat->dev);
-	/* fake it, otherwise it would depend on the trigger device names  */
-	sibling = ni_sibling_path_printf(origin, __NI_SUSE_CONFIG_IFPREFIX"%s", ovs_system);
-	ni_string_dup(&cs->config.origin, sibling);
+	return ifcfg;
 
-	ni_compat_netdev_array_append(netdevs, compat);
+error:
+	ni_suse_ifcfg_free(ifcfg);
+	return NULL;
 }
 
 static void
-__ni_suse_adjust_ovs_bridge_ports(ni_compat_netdev_array_t *netdevs, ni_compat_netdev_t *master)
+ni_suse_ifcfg_set_hotplug(ni_suse_ifcfg_t *ifcfg)
 {
-	ni_ovs_bridge_t *ovsbr = ni_netdev_get_ovs_bridge(master->dev);
-	static const char *ovs_system = NULL;
-	ni_compat_netdev_t *compat;
-	ni_ovs_bridge_port_t *p;
-	ni_client_state_t *cs;
-	const char *port;
-	unsigned int i;
+	static const ni_ifworker_control_t control = {
+		"hotplug", NULL, FALSE, FALSE, NI_TRISTATE_DEFAULT, 0, 0
+	};
 
-	if (ovs_system == NULL)
-		ovs_system = ni_linktype_type_to_name(NI_IFTYPE_OVS_SYSTEM);
+	if (ifcfg->compat->control)
+		ni_ifworker_control_free(ifcfg->compat->control);
 
-	cs = ni_netdev_get_client_state(master->dev);
-	__ni_suse_create_ovs_system(netdevs, ovs_system, cs->config.origin);
-	for (i = 0; i < ovsbr->ports.count; ++i) {
-		p = ovsbr->ports.data[i];
-		port = p->device.name;
-		compat = __ni_suse_find_compat(netdevs, port);
-		if (compat) {
-			if (__ni_suse_set_link_master(compat->dev, ovs_system, master->dev->name)) {
-				compat->port.type = NI_IFTYPE_OVS_BRIDGE;
-				ni_netdev_ref_set_ifname(&compat->port.conf.ovsbr.bridge, master->dev->name);
-			}
-		} else
-		if ((compat = __ni_suse_create_compat_slave(netdevs, master, ovs_system, port))) {
-			compat->port.type = NI_IFTYPE_OVS_BRIDGE;
-			ni_netdev_ref_set_ifname(&compat->port.conf.ovsbr.bridge, master->dev->name);
-		}
-	}
+	/* apply STARTMODE=hotplug (missing Ok) control defaults */
+	ifcfg->compat->control = ni_ifworker_control_clone(&control);
 }
 
 static void
-__ni_suse_adjust_slaves(ni_compat_netdev_array_t *netdevs)
+ni_suse_ifcfg_set_l2_only(ni_suse_ifcfg_t *ifcfg, ni_bool_t l2v6)
 {
-	ni_compat_netdev_t *compat;
-	ni_netdev_t *dev;
-	unsigned int i;
-
-	for (i = 0; i < netdevs->count; ++i) {
-		compat = netdevs->data[i];
-		dev = compat->dev;
+	ni_ipv4_devinfo_t *ipv4;
+	ni_ipv6_devinfo_t *ipv6;
 
-		switch (dev->link.type) {
-		case NI_IFTYPE_BOND:
-			__ni_suse_adjust_bond_slaves(netdevs, compat);
-			break;
-		case NI_IFTYPE_BRIDGE:
-			__ni_suse_adjust_bridge_ports(netdevs, compat);
-			break;
-		case NI_IFTYPE_OVS_BRIDGE:
-			__ni_suse_adjust_ovs_bridge_ports(netdevs, compat);
-			break;
-		case NI_IFTYPE_TEAM:
-			__ni_suse_adjust_team_ports(netdevs, compat);
-		default:
-			break;
-		}
+	/* apply BOOTPROTO=none (no L3) defaults in L2 enslave;
+	 * link monitoring may need ipv6 (link layer address) */
+	if ((ipv4 = ni_netdev_get_ipv4(ifcfg->compat->dev)))
+		ni_tristate_set(&ipv4->conf.enabled, FALSE);
+	if ((ipv6 = ni_netdev_get_ipv6(ifcfg->compat->dev))) {
+		/* ipv6 link only without RA for L3 setup */
+		ni_tristate_set(&ipv6->conf.enabled, l2v6);
+		ni_tristate_set(&ipv6->conf.accept_ra, 0);
 	}
+	ifcfg->l2only = TRUE;
 }
 
 static ni_bool_t
-__ni_suse_read_linkinfo(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+ni_suse_ifcfg_netdev_set_master(ni_netdev_t *pdev, ni_netdev_t *mdev,
+		const char *type, const char *file)
 {
-	ni_netdev_t *dev = compat->dev;
-	const char *master;
+	if (ni_string_empty(pdev->link.masterdev.name))
+		return ni_netdev_ref_set_ifname(&pdev->link.masterdev, mdev->name);
 
-	ni_sysconfig_get_integer(sc, "MTU", &dev->link.mtu);
-
-	if (!ni_string_empty(master = ni_sysconfig_get_value(sc, "MASTER_DEVICE"))) {
-		if (!__ni_suse_set_link_master(dev, master, dev->name))
-			return FALSE;
+	if (ni_string_eq(pdev->link.masterdev.name, mdev->name)) {
+		ni_warn("ifcfg-%s: ignoring duplicate '%s' %s port '%s'",
+				file, mdev->name, type, pdev->name);
+		return TRUE;
 	}
 
-	return TRUE;
+	/*
+	 * The ifcfg device hierarchy _is_ broken.
+	 *
+	 * As we cannot judge which config is correct and which not,
+	 * we keep the already assigned interface intact and let
+	 * further layers decide how to handle this condition.
+	 */
+	ni_error("ifcfg-%s: cannot add %s port '%s' to '%s', already in '%s'",
+			file, type, pdev->name, mdev->name,
+			pdev->link.masterdev.name);
+	return FALSE;
 }
 
-/*
- * Read an ifcfg file
- */
-static ni_bool_t
-__ni_suse_sysconfig_read(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
-{
-	compat->control = __ni_suse_startmode(sc);
-
-	if (try_loopback(sc, compat)   < 0 ||
-	    try_ovs_system(sc, compat) < 0 ||
-	    try_ovs_bridge(sc, compat) < 0 ||
-	    try_bonding(sc, compat)    < 0 ||
-	    try_team(sc, compat)       < 0 ||
-	    try_bridge(sc, compat)     < 0 ||
-	    try_vlan(sc, compat)       < 0 ||
-	    try_vxlan(sc, compat)      < 0 ||
-	    try_macvlan(sc, compat)    < 0 ||
-	    try_dummy(sc, compat)      < 0 ||
-	    try_tunnel(sc, compat)     < 0 ||
-	    try_ppp(sc, compat)        < 0 ||
-	    try_wireless(sc, compat)   < 0 ||
-	    try_infiniband(sc, compat) < 0 ||
-	    /* keep ethernet the last one */
-	    try_ethernet(sc, compat)   < 0)
-		return FALSE;
+static ni_suse_ifcfg_t *
+ni_suse_ifcfg_add_l2_port(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *mcfg,
+		const char *file, const char *type, const char *port, ni_bool_t l2v6)
+{
+	ni_suse_ifcfg_t *pcfg;
+	ni_netdev_t *mdev;
 
-	if (compat->dev->link.type == NI_IFTYPE_OVS_SYSTEM)
-		return TRUE;
+	mdev = mcfg->compat->dev;
+	if (!ni_netdev_name_is_valid(port) || ni_string_eq(mdev->name, port)) {
+		ni_error("ifcfg-%s: rejecting invalid '%s' %s port name '%s'",
+				mdev->name, file, type, port);
+		return NULL;
+	}
 
-	__ni_suse_read_linkinfo(sc, compat);
-	__ni_suse_read_ifsysctl(sc, compat);
-	__ni_suse_bootproto(sc, compat);
-	__ni_suse_get_scripts(sc, compat);
-	ni_suse_ifcfg_get_firewall(sc, compat);
-	ni_suse_ifcfg_get_ethtool(sc, compat);
+	if (!(pcfg = ni_suse_ifcfg_find_by_ifname(ifcfgs, port))) {
+		pcfg = ni_suse_ifcfg_new_missing(mcfg, port);
+		if (!ni_suse_ifcfg_array_append(ifcfgs, pcfg)) {
+			ni_suse_ifcfg_free(pcfg);
+			ni_error("ifcfg-%s: failed to add %s port '%s' to '%s'",
+					file, type, port, mdev->name);
+			return NULL;
+		}
+		ni_suse_ifcfg_set_hotplug(pcfg);
+	}
+	ni_suse_ifcfg_set_l2_only(pcfg, l2v6);
 
-	/* FIXME: What to do with these:
-		NAME
-	 */
+	if (ni_suse_ifcfg_netdev_set_master(pcfg->compat->dev, mdev, type, file))
+		return pcfg;
 
-	return TRUE;
+	pcfg->broken = TRUE;
+	return NULL;
 }
 
-/*
- * Given a basename like "IPADDR", try to find all variables with this
- * prefix (eg "IPADDR", "IPADDR_0", "IPADDR_1", ...) and invoke the provided function
- * for each. Note, this passes the variable suffix ("", "_0", "_1") rather than
- * the full variable name into the called function.
- */
-static int
-__process_indexed_variables(const ni_sysconfig_t *sc, ni_netdev_t *dev,
-				const char *basename,
-				ni_bool_t (*func)(const ni_sysconfig_t *, ni_netdev_t *, const char *))
+static ni_suse_ifcfg_t *
+ni_suse_ifcfg_add_lower(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg,
+		const char *lower, const char *info)
 {
-	ni_string_array_t names = NI_STRING_ARRAY_INIT;
-	unsigned int i, pfxlen;
+	ni_netdev_t *dev = ifcfg->compat->dev;
+	ni_suse_ifcfg_t *cfg;
 
-	if (!ni_sysconfig_find_matching(sc, basename, &names))
-		return 1;
+	if (!ni_netdev_name_is_valid(lower) || ni_string_eq(dev->name, lower)) {
+		ni_error("ifcfg-%s: rejecting invalid %s '%s' of '%s'",
+				dev->name, info ?: "lower interface",
+				lower, dev->name);
+		return NULL;
+	}
 
-	pfxlen = strlen(basename);
-	for (i = 0; i < names.count; ++i) {
-		if (!func(sc, dev, names.data[i] + pfxlen)) {
-			ni_string_array_destroy(&names);
-			return -1;
+	if (!(cfg = ni_suse_ifcfg_find_by_ifname(ifcfgs, lower))) {
+		cfg = ni_suse_ifcfg_new_missing(ifcfg, lower);
+		if (!ni_suse_ifcfg_array_append(ifcfgs, cfg)) {
+			ni_suse_ifcfg_free(cfg);
+			ni_error("ifcfg-%s: failed to add missing %s '%s' for '%s",
+					dev->name, info ?: "lower interface",
+					lower, dev->name);
+			return NULL;
 		}
+		ni_warn("ifcfg-%s: generated missing %s '%s' config for '%s'",
+			dev->name, info ?: "lower interface",
+			lower, dev->name);
+
+		/* Inherit from depending somehow? */
+		ni_suse_ifcfg_set_hotplug(cfg);
 	}
-	ni_string_array_destroy(&names);
-	return 0;
+	return cfg;
 }
 
-/*
- * Given a base name and a suffix (eg "IPADDR" and "_1"), build a variable name
- * and look it up.
- */
-static ni_var_t *
-__find_indexed_variable(const ni_sysconfig_t *sc, const char *basename, const char *suffix)
+static ni_suse_ifcfg_t *
+ni_suse_ifcfg_find_by_ifname(ni_suse_ifcfg_array_t *ifcfgs, const char *ifname)
 {
-	ni_var_t *res;
-	char namebuf[64];
+	ni_suse_ifcfg_t *ifcfg;
+	ni_netdev_t *dev;
+	unsigned int i;
 
-	snprintf(namebuf, sizeof(namebuf), "%s%s", basename, suffix);
-	res = ni_sysconfig_get(sc, namebuf);
-	if (res && (res->value == NULL || res->value[0] == '\0'))
-		res = NULL;
-	return res;
+	if (!ifcfgs || !ifname)
+		return NULL;
+
+	for (i = 0; i < ifcfgs->count; ++i) {
+		ifcfg = ifcfgs->data[i];
+		dev = ifcfg->compat->dev;
+
+		if (ni_string_eq(dev->name, ifname))
+			return ifcfg;
+	}
+	return NULL;
+}
+
+static unsigned int
+ni_suse_ifcfg_process_indexed(ni_suse_ifcfg_array_t *ifcfgs,
+		ni_suse_ifcfg_t *ifcfg, const char *prefix,
+		ifcfg_process_fn_t process)
+{
+	const ni_var_t *var;
+	unsigned int cnt, i;
+	size_t pfxlen;
+
+	if (!ifcfgs || !ifcfg || !ifcfg->config || !process)
+		return 0;
+
+	pfxlen = ni_string_len(prefix);
+	for (cnt = 0, i = 0; i < ifcfg->config->vars.count; ++i) {
+		var = &ifcfg->config->vars.data[i];
+
+		if (!var->value || strncmp(var->name, prefix, pfxlen))
+			continue;
+
+		if (process(ifcfgs, ifcfg, var->value, var->name, var->name + pfxlen))
+			cnt++;
+	}
+	return cnt;
 }
+
+static ni_define_ptr_array_init(ni_suse_ifcfg);
+static ni_define_ptr_array_destroy(ni_suse_ifcfg);
+static ni_define_ptr_array_realloc(ni_suse_ifcfg, NI_SUSE_IFCFG_ARRAY_CHUNK);
+static ni_define_ptr_array_append(ni_suse_ifcfg);
diff --git a/client/wicked-client.h b/client/wicked-client.h
index 88c766c1c..d2bd987f1 100644
--- a/client/wicked-client.h
+++ b/client/wicked-client.h
@@ -32,8 +32,6 @@
 #include <wicked/addrconf.h>
 #include <wicked/route.h>
 #include <wicked/fsm.h>
-#include <wicked/ovs.h>
-#include <wicked/team.h>
 
 extern int			opt_global_dryrun;
 extern char *			opt_global_rootdir;
@@ -56,13 +54,7 @@ typedef struct ni_compat_netdev {
 		ni_hwaddr_t	hwaddr;
 	} identify;
 
-	struct {
-		ni_iftype_t				type;
-		union {
-			ni_ovs_bridge_port_config_t	ovsbr;
-			ni_team_port_config_t		team;
-		} conf;
-	} port;
+	ni_netdev_port_config_t	port;
 
 	ni_rule_array_t		rules;
 
